com.fasterxml.jackson.databind.introspect

## Class JacksonAnnotationIntrospector

- java.lang.Object
- - com.fasterxml.jackson.databind.AnnotationIntrospector
  - - com.fasterxml.jackson.databind.introspect.JacksonAnnotationIntrospector

All Implemented Interfaces:
  Versioned, Serializable

    public class JacksonAnnotationIntrospector
    extends AnnotationIntrospector
    implements Serializable

`AnnotationIntrospector` implementation that handles standard Jackson annotations.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.AnnotationIntrospector

`AnnotationIntrospector.Pair, AnnotationIntrospector.ReferenceProperty`

### Constructor Summary

Constructors
Constructor and Description
`JacksonAnnotationIntrospector()`

### Method Summary

Methods
`protected StdTypeResolverBuilder` `_constructNoTypeResolverBuilder()` Helper method for dealing with "no type info" marker; can't be null (as it'd be replaced by default typing)
`protected StdTypeResolverBuilder` `_constructStdTypeResolverBuilder()` Helper method for constructing standard `TypeResolverBuilder` implementation.
`protected TypeResolverBuilder<?>` `_findTypeResolver(MapperConfig<?> config, Annotated ann, JavaType baseType)` Helper method called to construct and initialize instance of `TypeResolverBuilder` if given annotated element indicates one is needed.
`protected boolean` `_isIgnorable(Annotated a)`
`VisibilityChecker<?>` `findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)` Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors).
`Class<? extends JsonDeserializer<?>>` `findContentDeserializer(Annotated a)` Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property.
`Class<? extends JsonSerializer<?>>` `findContentSerializer(Annotated a)` Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property.
`Object` `findDeserializationContentConverter(AnnotatedMember a)` Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).
`Class<?>` `findDeserializationContentType(Annotated am, JavaType baseContentType)` Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements.
`Object` `findDeserializationConverter(Annotated a)` Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of deserialization.
`Class<?>` `findDeserializationKeyType(Annotated am, JavaType baseKeyType)` Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use.
`String` `findDeserializationName(AnnotatedField af)` Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property.
`String` `findDeserializationName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter".
`String` `findDeserializationName(AnnotatedParameter param)` Method for checking whether given set of annotations indicates property name for associated parameter.
`Class<?>` `findDeserializationType(Annotated am, JavaType baseType)` Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type.
`Class<? extends JsonDeserializer<?>>` `findDeserializer(Annotated a)` Method for getting a deserializer definition on specified method or field.
`Object` `findFilterId(AnnotatedClass ac)` Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.
`JsonFormat.Value` `findFormat(Annotated annotated)` Method for finding format annotations for property or class.
`JsonFormat.Value` `findFormat(AnnotatedMember member)` Method for finding format annotations for given member.
`Boolean` `findIgnoreUnknownProperties(AnnotatedClass ac)` Method for checking whether an annotation indicates that all unknown properties
`Object` `findInjectableValueId(AnnotatedMember m)` Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection.
`Class<? extends KeyDeserializer>` `findKeyDeserializer(Annotated a)` Method for getting a deserializer definition for keys of associated `Map` property.
`Class<? extends JsonSerializer<?>>` `findKeySerializer(Annotated a)` Method for getting a serializer definition for keys of associated `Map` property.
`PropertyName` `findNameForDeserialization(Annotated a)` Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for deserialization (reading JSON into POJOs).
`PropertyName` `findNameForSerialization(Annotated a)` Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for serialization.
`Object` `findNamingStrategy(AnnotatedClass ac)` Method for finding `PropertyNamingStrategy` for given class, if any specified by annotations; and if so, either return a `PropertyNamingStrategy` instance, or Class to use for creating instance
`ObjectIdInfo` `findObjectIdInfo(Annotated ann)` Method for checking whether given annotated thing (type, or accessor) indicates that values referenced (values of type of annotated class, or values referenced by annotated property; latter having precedence) should include Object Identifier, and if so, specify details of Object Identity used.
`ObjectIdInfo` `findObjectReferenceInfo(Annotated ann, ObjectIdInfo objectIdInfo)` Method for figuring out additional properties of an Object Identity reference
`Class<?>` `findPOJOBuilder(AnnotatedClass ac)` Method for finding Builder object to use for constructing value instance and binding data (sort of combining value instantiators that can construct, and deserializers that can bind data).
`JsonPOJOBuilder.Value` `findPOJOBuilderConfig(AnnotatedClass ac)`
`String[]` `findPropertiesToIgnore(Annotated ac)` Method for finding list of properties to ignore for given class (null is returned if not specified).
`TypeResolverBuilder<?>` `findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType containerType)` Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values.
`TypeResolverBuilder<?>` `findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)` Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances.
`AnnotationIntrospector.ReferenceProperty` `findReferenceType(AnnotatedMember member)` Method for checking if given member indicates that it is part of a reference (parent/child).
`PropertyName` `findRootName(AnnotatedClass ac)` Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined.
`Object` `findSerializationContentConverter(AnnotatedMember a)` Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).
`Class<?>` `findSerializationContentType(Annotated am, JavaType baseType)` Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization.
`Object` `findSerializationConverter(Annotated a)` Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of serialization.
`JsonInclude.Include` `findSerializationInclusion(Annotated a, JsonInclude.Include defValue)` Method for checking whether given annotated entity (class, method, field) defines which Bean/Map properties are to be included in serialization.
`Class<?>` `findSerializationKeyType(Annotated am, JavaType baseType)` Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization.
`String` `findSerializationName(AnnotatedField af)` Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property.
`String` `findSerializationName(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter".
`String[]` `findSerializationPropertyOrder(AnnotatedClass ac)` Method for accessing defined property serialization order (which may be partial).
`Boolean` `findSerializationSortAlphabetically(AnnotatedClass ac)` Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
`Class<?>` `findSerializationType(Annotated am)` Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type.
`JsonSerialize.Typing` `findSerializationTyping(Annotated a)` Method for accessing declared typing mode annotated (if any).
`Object` `findSerializer(Annotated a)` Method for getting a serializer definition on specified method or field.
`List<NamedType>` `findSubtypes(Annotated a)` Method for locating annotation-specified subtypes related to annotated entity (class, method, field).
`String` `findTypeName(AnnotatedClass ac)` Method for checking if specified type has explicit name.
`TypeResolverBuilder<?>` `findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)` Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances.
`NameTransformer` `findUnwrappingNameTransformer(AnnotatedMember member)` Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e.
`Object` `findValueInstantiator(AnnotatedClass ac)` Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.
`Class<?>[]` `findViews(Annotated a)` Method for checking if annotated property (represented by a field or getter/setter method) has definitions for views it is to be included in.
`boolean` `hasAnyGetterAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.
`boolean` `hasAnySetterAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
`boolean` `hasAsValueAnnotation(AnnotatedMethod am)` Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
`boolean` `hasCreatorAnnotation(Annotated a)` Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.
`boolean` `hasIgnoreMarker(AnnotatedMember m)` Method called to check whether given property is marked to be ignored.
`Boolean` `hasRequiredMarker(AnnotatedMember m)` Method that can be called to check whether this member has an annotation that suggests whether value for matching property is required or not.
`boolean` `isAnnotationBundle(Annotation ann)` Annotations with meta-annotation `JacksonAnnotationsInside` are considered bundles.
`boolean` `isHandled(Annotation ann)` Deprecated.
`Boolean` `isIgnorableType(AnnotatedClass ac)` Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
`Boolean` `isTypeId(AnnotatedMember member)` Method for checking whether given accessor claims to represent type id: if so, its value may be used as an override, instead of generated type id.
`Version` `version()`

### Methods inherited from class com.fasterxml.jackson.databind.AnnotationIntrospector

`allIntrospectors, allIntrospectors, findEnumValue, findWrapperName, nopInstance, pair`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### JacksonAnnotationIntrospector

    public JacksonAnnotationIntrospector()

### Method Detail

#### version

    public Version version()

Specified by:
  `version` in interface `Versioned`
Specified by:
  `version` in class `AnnotationIntrospector`

#### isHandled

    @Deprecated
    public boolean isHandled(Annotation ann)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method called by framework to determine whether given annotation is handled by this introspector.

Overrides:
  `isHandled` in class `AnnotationIntrospector`

#### isAnnotationBundle

    public boolean isAnnotationBundle(Annotation ann)

Annotations with meta-annotation `JacksonAnnotationsInside` are considered bundles.

Overrides:
  `isAnnotationBundle` in class `AnnotationIntrospector`

#### findRootName

    public PropertyName findRootName(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined. Returns null if no declaration found; can return explicit empty String, which is usually ignored as well as null.

NOTE: method signature changed in 2.1, to return `PropertyName` instead of String.

Overrides:
  `findRootName` in class `AnnotationIntrospector`

#### findPropertiesToIgnore

    public String[] findPropertiesToIgnore(Annotated ac)

Description copied from class: `AnnotationIntrospector`
Method for finding list of properties to ignore for given class (null is returned if not specified). List of property names is applied after other detection mechanisms, to filter out these specific properties from being serialized and deserialized.

Overrides:
  `findPropertiesToIgnore` in class `AnnotationIntrospector`

#### findIgnoreUnknownProperties

    public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for checking whether an annotation indicates that all unknown properties

Overrides:
  `findIgnoreUnknownProperties` in class `AnnotationIntrospector`

#### isIgnorableType

    public Boolean isIgnorableType(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.

Overrides:
  `isIgnorableType` in class `AnnotationIntrospector`
Parameters:
  `ac` - Type to check
Returns:
  Boolean.TRUE if properties of type should be ignored; Boolean.FALSE if they are not to be ignored, null for default handling (which is 'do not ignore')

#### findFilterId

    public Object findFilterId(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.

Overrides:
  `findFilterId` in class `AnnotationIntrospector`
Returns:
  Id of the filter to use for filtering properties of annotated class, if any; or null if none found.

#### findNamingStrategy

    public Object findNamingStrategy(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for finding `PropertyNamingStrategy` for given class, if any specified by annotations; and if so, either return a `PropertyNamingStrategy` instance, or Class to use for creating instance

Overrides:
  `findNamingStrategy` in class `AnnotationIntrospector`
Returns:
  Sub-class or instance of `PropertyNamingStrategy`, if one is specified for given class; null if not.

#### findAutoDetectVisibility

    public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac,
                                                VisibilityChecker<?> checker)

Description copied from class: `AnnotationIntrospector`
Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors). A baseline checker is given, and introspector is to either return it as is (if no annotations are found), or build and return a derived instance (using checker's build methods).

Overrides:
  `findAutoDetectVisibility` in class `AnnotationIntrospector`

#### findReferenceType

    public AnnotationIntrospector.ReferenceProperty findReferenceType(AnnotatedMember member)

Description copied from class: `AnnotationIntrospector`
Method for checking if given member indicates that it is part of a reference (parent/child).

Overrides:
  `findReferenceType` in class `AnnotationIntrospector`

#### findUnwrappingNameTransformer

    public NameTransformer findUnwrappingNameTransformer(AnnotatedMember member)

Description copied from class: `AnnotationIntrospector`
Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e. expect unwrapped representation during deserialization). Return value is the name transformation to use, if wrapping/unwrapping should be done, or null if not -- note that transformation may simply be identity transformation (no changes).

Overrides:
  `findUnwrappingNameTransformer` in class `AnnotationIntrospector`

#### hasIgnoreMarker

    public boolean hasIgnoreMarker(AnnotatedMember m)

Description copied from class: `AnnotationIntrospector`
Method called to check whether given property is marked to be ignored. This is used to determine whether to ignore properties, on per-property basis, usually combining annotations from multiple accessors (getters, setters, fields, constructor parameters).

Overrides:
  `hasIgnoreMarker` in class `AnnotationIntrospector`

#### hasRequiredMarker

    public Boolean hasRequiredMarker(AnnotatedMember m)

Description copied from class: `AnnotationIntrospector`
Method that can be called to check whether this member has an annotation that suggests whether value for matching property is required or not.

Overrides:
  `hasRequiredMarker` in class `AnnotationIntrospector`

#### findInjectableValueId

    public Object findInjectableValueId(AnnotatedMember m)

Description copied from class: `AnnotationIntrospector`
Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection. Type if identifier needs to be compatible with provider of values (of type `InjectableValues`); often a simple String id is used.

Overrides:
  `findInjectableValueId` in class `AnnotationIntrospector`
Parameters:
  `m` - Member to check
Returns:
  Identifier of value to inject, if any; null if no injection indicator is found

#### findTypeResolver

    public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config,
                                          AnnotatedClass ac,
                                          JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findTypeResolver` in class `AnnotationIntrospector`
Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `ac` - Annotated class to check for annotations
  `baseType` - Base java type of value for which resolver is to be found
Returns:
  Type resolver builder for given type, if one found; null if none

#### findPropertyTypeResolver

    public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config,
                                                  AnnotatedMember am,
                                                  JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findPropertyTypeResolver` in class `AnnotationIntrospector`
Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `am` - Annotated member (field or method) to check for annotations
  `baseType` - Base java type of property for which resolver is to be found
Returns:
  Type resolver builder for properties of given entity, if one found; null if none

#### findPropertyContentTypeResolver

    public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config,
                                                         AnnotatedMember am,
                                                         JavaType containerType)

Description copied from class: `AnnotationIntrospector`
Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findPropertyContentTypeResolver` in class `AnnotationIntrospector`
Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `am` - Annotated member (field or method) to check for annotations
  `containerType` - Type of property for which resolver is to be found (must be a container type)
Returns:
  Type resolver builder for values contained in properties of given entity, if one found; null if none

#### findSubtypes

    public List<NamedType> findSubtypes(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for locating annotation-specified subtypes related to annotated entity (class, method, field). Note that this is only guaranteed to be a list of directly declared subtypes, no recursive processing is guarantees (i.e. caller has to do it if/as necessary)

Overrides:
  `findSubtypes` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated entity (class, field/method) to check for annotations

#### findTypeName

    public String findTypeName(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for checking if specified type has explicit name.

Overrides:
  `findTypeName` in class `AnnotationIntrospector`
Parameters:
  `ac` - Class to check for type name annotations

#### findSerializer

    public Object findSerializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a serializer definition on specified method or field. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findSerializer` in class `AnnotationIntrospector`

#### findKeySerializer

    public Class<? extends JsonSerializer<?>> findKeySerializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a serializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findKeySerializer` in class `AnnotationIntrospector`

#### findContentSerializer

    public Class<? extends JsonSerializer<?>> findContentSerializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findContentSerializer` in class `AnnotationIntrospector`

#### findSerializationInclusion

    public JsonInclude.Include findSerializationInclusion(Annotated a,
                                                 JsonInclude.Include defValue)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given annotated entity (class, method, field) defines which Bean/Map properties are to be included in serialization. If no annotation is found, method should return given second argument; otherwise value indicated by the annotation

Overrides:
  `findSerializationInclusion` in class `AnnotationIntrospector`
Returns:
  Enumerated value indicating which properties to include in serialization

#### findSerializationType

    public Class<?> findSerializationType(Annotated am)

Description copied from class: `AnnotationIntrospector`
Method for accessing annotated type definition that a method/field can have, to be used as the type for serialization instead of the runtime type. Type returned (if any) needs to be widening conversion (super-type). Declared return type of the method is also considered acceptable.

Overrides:
  `findSerializationType` in class `AnnotationIntrospector`
Returns:
  Class to use instead of runtime type

#### findSerializationKeyType

    public Class<?> findSerializationKeyType(Annotated am,
                                    JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization. It should be only be used with `Map` types.

Overrides:
  `findSerializationKeyType` in class `AnnotationIntrospector`
Returns:
  Class specifying more general type to use instead of declared type, if annotation found; null if not

#### findSerializationContentType

    public Class<?> findSerializationContentType(Annotated am,
                                        JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for finding possible widening type definition that a property value can have, to define less specific key type to use for serialization. It should be only used with structured types (arrays, collections, maps).

Overrides:
  `findSerializationContentType` in class `AnnotationIntrospector`
Returns:
  Class specifying more general type to use instead of declared type, if annotation found; null if not

#### findSerializationTyping

    public JsonSerialize.Typing findSerializationTyping(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for accessing declared typing mode annotated (if any). This is used for type detection, unless more granular settings (such as actual exact type; or serializer to use which means no type information is needed) take precedence.

Overrides:
  `findSerializationTyping` in class `AnnotationIntrospector`
Returns:
  Typing mode to use, if annotation is found; null otherwise

#### findSerializationConverter

    public Object findSerializationConverter(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of serialization. If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used first to convert property value to converter target type, and then serializer for that type is used for actual serialization.

This feature is typically used to convert internal values into types that Jackson can convert.

Note also that this feature does not necessarily work well with polymorphic type handling, or object identity handling; if such features are needed an explicit serializer is usually better way to handle serialization.

Overrides:
  `findSerializationConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) or class to check for annotations

#### findSerializationContentConverter

    public Object findSerializationContentConverter(AnnotatedMember a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).

If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used first to convert property value to converter target type, and then serializer for that type is used for actual serialization.

Other notes are same as those for `AnnotationIntrospector.findSerializationConverter(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findSerializationContentConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) to check.

#### findViews

    public Class<?>[] findViews(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking if annotated property (represented by a field or getter/setter method) has definitions for views it is to be included in. If null is returned, no view definitions exist and property is always included (or always excluded as per default view inclusion configuration); otherwise it will only be included for views included in returned array. View matches are checked using class inheritance rules (sub-classes inherit inclusions of super-classes)

Overrides:
  `findViews` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (represented by a method, field or ctor parameter)
Returns:
  Array of views (represented by classes) that the property is included in; if null, always included (same as returning array containing `Object.class`)

#### isTypeId

    public Boolean isTypeId(AnnotatedMember member)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given accessor claims to represent type id: if so, its value may be used as an override, instead of generated type id.

Overrides:
  `isTypeId` in class `AnnotationIntrospector`

#### findObjectIdInfo

    public ObjectIdInfo findObjectIdInfo(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given annotated thing (type, or accessor) indicates that values referenced (values of type of annotated class, or values referenced by annotated property; latter having precedence) should include Object Identifier, and if so, specify details of Object Identity used.

Overrides:
  `findObjectIdInfo` in class `AnnotationIntrospector`

#### findObjectReferenceInfo

    public ObjectIdInfo findObjectReferenceInfo(Annotated ann,
                                       ObjectIdInfo objectIdInfo)

Description copied from class: `AnnotationIntrospector`
Method for figuring out additional properties of an Object Identity reference

Overrides:
  `findObjectReferenceInfo` in class `AnnotationIntrospector`

#### findFormat

    public JsonFormat.Value findFormat(AnnotatedMember member)

Description copied from class: `AnnotationIntrospector`
Method for finding format annotations for given member. Return value is typically used by serializers and/or deserializers to customize presentation aspects of the serialized value.

Overrides:
  `findFormat` in class `AnnotationIntrospector`

#### findFormat

    public JsonFormat.Value findFormat(Annotated annotated)

Description copied from class: `AnnotationIntrospector`
Method for finding format annotations for property or class. Return value is typically used by serializers and/or deserializers to customize presentation aspects of the serialized value.

Overrides:
  `findFormat` in class `AnnotationIntrospector`

#### findSerializationPropertyOrder

    public String[] findSerializationPropertyOrder(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for accessing defined property serialization order (which may be partial). May return null if no ordering is defined.

Overrides:
  `findSerializationPropertyOrder` in class `AnnotationIntrospector`

#### findSerializationSortAlphabetically

    public Boolean findSerializationSortAlphabetically(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered

Overrides:
  `findSerializationSortAlphabetically` in class `AnnotationIntrospector`

#### findNameForSerialization

    public PropertyName findNameForSerialization(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for serialization. Should return null if no annotation is found; otherwise a non-null name (possibly `PropertyName.USE_DEFAULT`, which means "use default heuristics").

Overrides:
  `findNameForSerialization` in class `AnnotationIntrospector`
Parameters:
  `a` - Property accessor to check
Returns:
  Name to use if found; null if not.

#### findSerializationName

    public String findSerializationName(AnnotatedField af)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given member field represent a serializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a serializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".

Overrides:
  `findSerializationName` in class `AnnotationIntrospector`

#### findSerializationName

    public String findSerializationName(AnnotatedMethod am)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests property name associated with method that may be a "getter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".

Overrides:
  `findSerializationName` in class `AnnotationIntrospector`

#### hasAsValueAnnotation

    public boolean hasAsValueAnnotation(AnnotatedMethod am)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.

Overrides:
  `hasAsValueAnnotation` in class `AnnotationIntrospector`
Returns:
  True if such annotation is found (and is not disabled); false if no enabled annotation is found

#### findDeserializer

    public Class<? extends JsonDeserializer<?>> findDeserializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a deserializer definition on specified method or field. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findDeserializer` in class `AnnotationIntrospector`

#### findKeyDeserializer

    public Class<? extends KeyDeserializer> findKeyDeserializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a deserializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findKeyDeserializer` in class `AnnotationIntrospector`

#### findContentDeserializer

    public Class<? extends JsonDeserializer<?>> findContentDeserializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findContentDeserializer` in class `AnnotationIntrospector`

#### findDeserializationType

    public Class<?> findDeserializationType(Annotated am,
                                   JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for accessing annotated type definition that a method can have, to be used as the type for serialization instead of the runtime type. Type must be a narrowing conversion (i.e.subtype of declared type). Declared return type of the method is also considered acceptable.

Overrides:
  `findDeserializationType` in class `AnnotationIntrospector`
  `baseType` - Assumed type before considering annotations
Returns:
  Class to use for deserialization instead of declared type

#### findDeserializationKeyType

    public Class<?> findDeserializationKeyType(Annotated am,
                                      JavaType baseKeyType)

Description copied from class: `AnnotationIntrospector`
Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use. It should be only be used with `Map` types.

Overrides:
  `findDeserializationKeyType` in class `AnnotationIntrospector`
  `baseKeyType` - Assumed key type before considering annotations
Returns:
  Class specifying more specific type to use instead of declared type, if annotation found; null if not

#### findDeserializationContentType

    public Class<?> findDeserializationContentType(Annotated am,
                                          JavaType baseContentType)

Description copied from class: `AnnotationIntrospector`
Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements. It should be only be used with Map, Collection and array types.

Overrides:
  `findDeserializationContentType` in class `AnnotationIntrospector`
  `baseContentType` - Assumed content (value) type before considering annotations
Returns:
  Class specifying more specific type to use instead of declared type, if annotation found; null if not

#### findDeserializationConverter

    public Object findDeserializationConverter(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of deserialization. If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used after Jackson has deserializer data into intermediate type (Converter input type), and Converter needs to convert this into its target type to be set as property value.

This feature is typically used to convert intermediate Jackson types (that default deserializers can produce) into custom type instances.

Note also that this feature does not necessarily work well with polymorphic type handling, or object identity handling; if such features are needed an explicit deserializer is usually better way to handle deserialization.

Overrides:
  `findDeserializationConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) or class to check for annotations

#### findDeserializationContentConverter

    public Object findDeserializationContentConverter(AnnotatedMember a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).

If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used after Jackson has deserializer data into intermediate type (Converter input type), and Converter needs to convert this into its target type to be set as property value.

Other notes are same as those for `AnnotationIntrospector.findDeserializationConverter(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findDeserializationContentConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) to check.

#### findValueInstantiator

    public Object findValueInstantiator(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.

Overrides:
  `findValueInstantiator` in class `AnnotationIntrospector`

#### findPOJOBuilder

    public Class<?> findPOJOBuilder(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for finding Builder object to use for constructing value instance and binding data (sort of combining value instantiators that can construct, and deserializers that can bind data).

Note that unlike accessors for some helper Objects, this method does not allow returning instances: the reason is that builders have state, and a separate instance needs to be created for each deserialization call.

Overrides:
  `findPOJOBuilder` in class `AnnotationIntrospector`

#### findPOJOBuilderConfig

    public JsonPOJOBuilder.Value findPOJOBuilderConfig(AnnotatedClass ac)

Overrides:
  `findPOJOBuilderConfig` in class `AnnotationIntrospector`

#### findNameForDeserialization

    public PropertyName findNameForDeserialization(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for deserialization (reading JSON into POJOs). Should return null if no annotation is found; otherwise a non-null name (possibly `PropertyName.USE_DEFAULT`, which means "use default heuristics").

Overrides:
  `findNameForDeserialization` in class `AnnotationIntrospector`
Parameters:
  `a` - Property accessor to check
Returns:
  Name to use if found; null if not.

#### findDeserializationName

    public String findDeserializationName(AnnotatedMethod am)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests property name associated with method that may be a "setter". Should return null if no annotation is found; otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use standard bean name detection if applicable; method name if not".

Overrides:
  `findDeserializationName` in class `AnnotationIntrospector`

#### findDeserializationName

    public String findDeserializationName(AnnotatedField af)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given member field represent a deserializable logical property; and if so, returns the name of that property. Should return null if no annotation is found (indicating it is not a deserializable field); otherwise a non-null String. If non-null value is returned, it is used as the property name, except for empty String ("") which is taken to mean "use the field name as is".

Overrides:
  `findDeserializationName` in class `AnnotationIntrospector`

#### findDeserializationName

    public String findDeserializationName(AnnotatedParameter param)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given set of annotations indicates property name for associated parameter. No actual parameter object can be passed since JDK offers no representation; just annotations.

Overrides:
  `findDeserializationName` in class `AnnotationIntrospector`

#### hasAnySetterAnnotation

    public boolean hasAnySetterAnnotation(AnnotatedMethod am)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.

Overrides:
  `hasAnySetterAnnotation` in class `AnnotationIntrospector`
Returns:
  True if such annotation is found (and is not disabled), false otherwise

#### hasAnyGetterAnnotation

    public boolean hasAnyGetterAnnotation(AnnotatedMethod am)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.

Overrides:
  `hasAnyGetterAnnotation` in class `AnnotationIntrospector`
Returns:
  True if such annotation is found (and is not disabled), false otherwise

#### hasCreatorAnnotation

    public boolean hasCreatorAnnotation(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.

Overrides:
  `hasCreatorAnnotation` in class `AnnotationIntrospector`
Returns:
  True if such annotation is found (and is not disabled), false otherwise

#### _isIgnorable

    protected boolean _isIgnorable(Annotated a)

#### _findTypeResolver

    protected TypeResolverBuilder<?> _findTypeResolver(MapperConfig<?> config,
                                           Annotated ann,
                                           JavaType baseType)

Helper method called to construct and initialize instance of `TypeResolverBuilder` if given annotated element indicates one is needed.

#### _constructStdTypeResolverBuilder

    protected StdTypeResolverBuilder _constructStdTypeResolverBuilder()

Helper method for constructing standard `TypeResolverBuilder` implementation.

#### _constructNoTypeResolverBuilder

    protected StdTypeResolverBuilder _constructNoTypeResolverBuilder()

Helper method for dealing with "no type info" marker; can't be null (as it'd be replaced by default typing)